searchData={"items":[{"type":"module","title":"TypedStructDataFrame","doc":"","ref":"TypedStructDataFrame.html"},{"type":"extras","title":"TypedStructDataFrame","doc":"# TypedStructDataFrame\n\nTypedStructDataFrame is a plugin library for the [TypedStruct](https://github.com/ejpcmac/typed_struct) library","ref":"readme.html"},{"type":"extras","title":"Rationale - TypedStructDataFrame","doc":"Explorer.DataFrames are a powerful way to manipulate large datasets, this library provides a quick and easy way to take these DataFrames and convert them to a type safe struct(s) or vice versa.\n\nComes installed with Money and Decimal packages to support the Money types and Decimal types. See example below","ref":"readme.html#rationale"},{"type":"extras","title":"TODO - TypedStructDataFrame","doc":"- [ ] Add support for abstract types to be defined by user of library\n- [ ] Add support for latest Explorer.DataFrame version","ref":"readme.html#todo"},{"type":"extras","title":"Installation - TypedStructDataFrame","doc":"To use TypedStructDataFrame in your project, add this to your Mix dependencies:\n\n```elixir\n  {:typed_struct_data_frame, \"~> 0.1.0\"}\n```\n\nand then use this by adding this plugin to any TypedStruct\n\n```elixir\n  plugin(TypedStructDataFrame)\n```\n\nDocumentation can be generated with [ExDoc](https://github.com/elixir-lang/ex_doc)\nand published on [HexDocs](https://hexdocs.pm). Once published, the docs can\nbe found at  .","ref":"readme.html#installation"},{"type":"extras","title":"Example - TypedStructDataFrame","doc":"```elixir\n  defmodule PersonProfile do\n    use TypedStruct\n\n    typedstruct do\n      plugin(TypedStructDataFrame)\n\n        field :name, :string\n        field :age, :integer\n        field :is_developer, :boolean\n        field :score, :decimal\n        field :net_worth, Money.Ecto.Amount.Type\n    end\n  end\n\n  iex> PersonProfile.dtypes()\n  [name: :string, age: :integer, is_developer: :boolean, score: :float, net_worth: :float]\n\n  iex> PersonProfile.empty_df()\n  #Explorer.DataFrame \n\n  iex > profile = %PersonProfile{name: \"Kevin\", age: 25, is_developer: true, score: Decimal.from_float(5.0), net_worth: Money.new(100_00, :USD)}\n  iex > df = PersonProfile.to_dataframe(profile)\n  #Explorer.DataFrame \n\n  iex > PersonProfile.from_dataframe(df)\n  [\n    %PersonProfile{\n      net_worth: %Money{amount: 10000, currency: :USD},\n      score: Decimal.new(\"5.0\"),\n      is_developer: true,\n      age: 25,\n      name: \"Kevin\"\n    }\n  ]\n```","ref":"readme.html#example"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,49,46,50]}}